package cn.com.ctop.kuaishou.modules.ai.entity;

import java.io.Serializable;
import java.util.Date;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;

/**
 * 落地页账户项目关联表
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2021-05-11
 */
@Data
@TableName("ctop_kuaishou_landpage_package")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_kuaishou_landpage_package对象", description = "落地页账户项目关联表")
public class KuaishouLandpagePackage {

    /**
     * id
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "id")
    private Long id;
    /**
     * 项目ID
     */
    @Excel(name = "项目ID", width = 15)
    @ApiModelProperty(value = "项目ID")
    private Long projectId;
    /**
     * 账户ID
     */
    @Excel(name = "账户ID", width = 15)
    @ApiModelProperty(value = "账户ID")
    private Long accountId;
    /**
     * 落地页名称
     */
    @Excel(name = "落地页名称", width = 15)
    @ApiModelProperty(value = "落地页名称")
    private String landpageName;
    /**
     * 落地页ID
     */
    @Excel(name = "落地页ID", width = 15)
    @ApiModelProperty(value = "落地页ID")
    private Long siteId;
    /**
     * 落地页URL
     */
    @Excel(name = "落地页URL", width = 15)
    @ApiModelProperty(value = "落地页URL")
    private String url;
    /**
     * 落地页类型	0：站内；1：联盟
     */
    @Excel(name = "落地页类型	0：站内；1：联盟", width = 15)
    @ApiModelProperty(value = "落地页类型	0：站内；1：联盟")
    private Integer bizType;
    /**
     * 应用ID
     */
    @Excel(name = "应用ID", width = 15)
    @ApiModelProperty(value = "应用ID")
    private Long appId;
    /**
     * 组件数据
     */
    @Excel(name = "组件数据", width = 15)
    @ApiModelProperty(value = "组件数据")
    private String comps;
    /**
     * 落地页创建时间
     */
    @Excel(name = "落地页创建时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "落地页创建时间")
    private Date landpageCreateTime;
    /**
     * 落地页修改时间
     */
    @Excel(name = "落地页修改时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "落地页修改时间")
    private Date landpageUpdateTime;
    /**
     * 创建时间
     */
    @Excel(name = "创建时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 修改时间
     */
    @Excel(name = "修改时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "修改时间")
    private Date updateTime;
}
